function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

import { PureComponent, Component, createElement, createRef } from 'rax';
import View from 'rax-view';
import ScrollView from 'rax-scrollview';
import RefreshControl from 'rax-refreshcontrol';
import cloneElement from 'rax-clone-element';
import omit from '../utils/omit';

var Header = /*#__PURE__*/function (_PureComponent) {
  _inheritsLoose(Header, _PureComponent);

  function Header() {
    return _PureComponent.apply(this, arguments) || this;
  }

  var _proto = Header.prototype;

  _proto.render = function render() {
    return createElement(View, this.props);
  };

  return Header;
}(PureComponent);

var WebFall = /*#__PURE__*/function (_PureComponent2) {
  _inheritsLoose(WebFall, _PureComponent2);

  function WebFall() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _PureComponent2.call.apply(_PureComponent2, [this].concat(args)) || this;

    _this.calcHeightSum = function (arr) {
      var sum = 0;
      arr && arr.forEach(function (item) {
        sum += item;
      });
      return sum;
    };

    return _this;
  }

  var _proto2 = WebFall.prototype;

  _proto2.render = function render() {
    var _this$props = this.props,
        _this$props$renderIte = _this$props.renderItem,
        renderItem = _this$props$renderIte === void 0 ? function () {} : _this$props$renderIte,
        dataSource = _this$props.dataSource,
        _this$props$columnCou = _this$props.columnCount,
        columnCount = _this$props$columnCou === void 0 ? 1 : _this$props$columnCou,
        _this$props$leftGap = _this$props.leftGap,
        leftGap = _this$props$leftGap === void 0 ? 0 : _this$props$leftGap,
        _this$props$rightGap = _this$props.rightGap,
        rightGap = _this$props$rightGap === void 0 ? 0 : _this$props$rightGap;
    var columns = [];
    var moduleHeights = [];

    for (var i = 0; i < columnCount; i++) {
      columns[i] = [];
      moduleHeights[i] = 0;
    }

    dataSource && dataSource.forEach(function (item) {
      var targetColumnIndex = 0;
      var minHeight = moduleHeights[0];

      for (var j = 0; j < columnCount; j++) {
        if (moduleHeights[j] < minHeight) {
          minHeight = moduleHeights[j];
          targetColumnIndex = j;
        }
      }

      moduleHeights[targetColumnIndex] += item.height;
      columns[targetColumnIndex].push(item);
    });
    var wrapStyle = Object.assign({}, styles.waterfallWrap, {
      marginLeft: leftGap + 'rpx',
      marginRight: rightGap + 'rpx'
    });
    return createElement(View, {
      style: wrapStyle
    }, columns.map(function (column, index) {
      return createElement(View, {
        key: 'column' + index,
        style: styles.waterfallColumn
      }, column.map(function (item, j) {
        return renderItem(item, 'c_' + index + j);
      }));
    }));
  };

  return WebFall;
}(PureComponent);

var Waterfall = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Waterfall, _Component);

  function Waterfall(props) {
    var _this2 = _Component.call(this, props) || this;

    _this2.loadmoreretry = 1;

    _this2.resetScroll = function () {
      _this2.scrollview.current && _this2.scrollview.current.resetScroll();
    };

    _this2.scrollTo = function (options) {
      _this2.scrollview.current && _this2.scrollview.current.scrollTo(options);
    };

    _this2.state = {
      loadmoreretry: 0
    };
    _this2.scrollview = createRef();
    return _this2;
  }

  var _proto3 = Waterfall.prototype;

  _proto3.render = function render() {
    var props = this.props;
    var renderHeader = props.renderHeader,
        renderFooter = props.renderFooter,
        _props$columnWidth = props.columnWidth,
        columnWidth = _props$columnWidth === void 0 ? 750 : _props$columnWidth;
    var header = typeof renderHeader == 'function' ? renderHeader() : null;
    var footer = typeof renderFooter == 'function' ? renderFooter() : null;
    header = Array.isArray(header) ? header : [header];
    footer = Array.isArray(footer) ? footer : [footer];
    var cells = header.map(function (child, index) {
      if (child) {
        if (child.type != RefreshControl && child.type != Header) {
          return createElement(Header, {
            key: 'waterfall_header_' + index
          }, child);
        } else {
          return cloneElement(child, {});
        }
      }
    });
    cells = cells.concat(createElement(WebFall, _extends({
      key: 'waterfall_webfall'
    }, props)));
    cells = cells.concat(footer.map(function (child, index) {
      if (child) {
        if (child.type != Header) {
          return createElement(Header, {
            key: 'waterfall_header_' + index
          }, child);
        } else {
          return cloneElement(child, {});
        }
      }
    }));
    styles.waterfallColumn.width = columnWidth;
    var omittedProps = omit(props, ['dataSource', 'renderItem', 'renderHeader', 'renderFooter', 'columnWidth', 'columnCount', 'columnGap', 'cellProps', 'leftGap', 'rightGap']);
    return createElement(ScrollView, _extends({}, omittedProps, {
      ref: this.scrollview
    }), cells);
  };

  return Waterfall;
}(Component);

var styles = {
  waterfallWrap: {
    overflow: 'hidden',
    flexDirection: 'row',
    justifyContent: 'space-between'
  },
  waterfallColumn: {}
};
Waterfall.Header = Header;
export default Waterfall;