var _excluded = ["onEndReachedThreshold"];

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

import { PureComponent, Component, createElement, createRef } from 'rax';
import RefreshControl from 'rax-refreshcontrol';
import cloneElement from 'rax-clone-element';

var Header = /*#__PURE__*/function (_PureComponent) {
  _inheritsLoose(Header, _PureComponent);

  function Header() {
    return _PureComponent.apply(this, arguments) || this;
  }

  var _proto = Header.prototype;

  _proto.render = function render() {
    return createElement("header", _extends({}, this.props, {
      append: "tree"
    }));
  };

  return Header;
}(PureComponent);

var Waterfall = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Waterfall, _Component);

  function Waterfall(props) {
    var _this = _Component.call(this, props) || this;

    _this.loadmoreretry = 1;

    _this.resetScroll = function () {
      if (_this.waterfall.current) {
        _this.setState({
          loadmoreretry: _this.loadmoreretry++ // for weex 0.9-

        });

        _this.waterfall.current.resetLoadmore && _this.waterfall.current.resetLoadmore(); // for weex 0.9+.
      }
    };

    _this.state = {
      loadmoreretry: 0
    };
    _this.waterfall = createRef();
    _this.topRef = createRef();
    return _this;
  }

  var _proto2 = Waterfall.prototype;

  _proto2.scrollTo = function scrollTo(options) {
    var _ref = options || {},
        _ref$x = _ref.x,
        x = _ref$x === void 0 ? 0 : _ref$x,
        _ref$y = _ref.y,
        y = _ref$y === void 0 ? 0 : _ref$y,
        _ref$animated = _ref.animated,
        animated = _ref$animated === void 0 ? true : _ref$animated;

    var dom = __weex_require__('@weex-module/dom');

    var contentContainer = this.topRef.current;
    contentContainer && dom.scrollToElement(contentContainer, {
      offset: x || y || 0,
      animated: animated
    });
  };

  _proto2.render = function render() {
    var _this2 = this;

    var props = this.props;
    var renderHeader = props.renderHeader,
        renderFooter = props.renderFooter,
        dataSource = props.dataSource,
        _props$cellProps = props.cellProps,
        cellProps = _props$cellProps === void 0 ? {} : _props$cellProps,
        _props$renderItem = props.renderItem,
        renderItem = _props$renderItem === void 0 ? function () {} : _props$renderItem;
    var header = typeof renderHeader == 'function' ? renderHeader() : null;
    var footer = typeof renderFooter == 'function' ? renderFooter() : null;
    header = Array.isArray(header) ? header : [header];
    footer = Array.isArray(footer) ? footer : [footer];
    var cells = header.map(function (child, index) {
      if (child) {
        if (child.type != RefreshControl && child.type != Header) {
          return createElement(Header, {
            key: 'waterfall_header_' + index
          }, child);
        } else {
          return cloneElement(child, {});
        }
      }
    });
    dataSource && dataSource.forEach(function (item, index) {
      if (index === 0) {
        cells.push(createElement("cell", _extends({
          key: 'waterfall_cell_' + index,
          ref: _this2.topRef
        }, cellProps), renderItem(item, index)));
      } else {
        cells.push(createElement("cell", _extends({
          key: 'waterfall_cell_' + index
        }, cellProps), renderItem(item, index)));
      }
    });
    cells = cells.concat(footer.map(function (child, index) {
      if (child) {
        if (child.type != Header) {
          return createElement(Header, {
            key: 'waterfall_footer_' + index
          }, child);
        } else {
          return cloneElement(child, {});
        }
      }
    }));

    var onEndReachedThreshold = props.onEndReachedThreshold,
        rest = _objectWithoutPropertiesLoose(props, _excluded);

    return createElement("waterfall", _extends({
      ref: this.waterfall,
      style: {
        width: 750
      }
    }, rest, {
      onLoadmore: props.onEndReached,
      loadmoreoffset: onEndReachedThreshold,
      loadmoreretry: this.state.loadmoreretry
    }), cells);
  };

  return Waterfall;
}(Component);

Waterfall.Header = Header;
export default Waterfall;